package com.jpattern.orm.test.session;

import org.junit.Test;

import com.jpattern.orm.SharedBaseTest;
import com.jpattern.orm.classtool.NullOrmClassToolMap;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.session.ISessionProvider;
import com.jpattern.orm.session.Session;
import com.jpattern.orm.transaction.ITransaction;

/**
 * 
 * @author Francesco Cina
 *
 * 05/giu/2011
 */
public class DataSourceConnectionTest extends SharedBaseTest {

	@Override
	protected void setUp() throws Exception {
	}

	@Override
	protected void tearDown() throws Exception {
	}

	@Test
	public void testConnections() throws Exception {
		final ISessionProvider provider = getJPOrm().getSessionProvider();
		loopTransaction( provider );
		loopConnection( provider );
	}

	public void loopTransaction(ISessionProvider dsProvider) throws Exception {
		final ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());

		final int howMany = 1000;

		for (int i=0; i<howMany; i++) {
			final ITransaction tx = conn.beginTransaction();
			tx.commit();
			System.out.println("commit: " + i);
		}

		for (int i=0; i<howMany; i++) {
			final ITransaction tx = conn.beginTransaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}

	public void loopConnection(ISessionProvider dsProvider) throws Exception {

		final int howMany = 100;

		for (int i=0; i<howMany; i++) {
			final ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());
			final ITransaction tx = conn.beginTransaction();
			tx.commit();
			System.out.println("commit: " + i);
		}

		for (int i=0; i<howMany; i++) {
			final ISession conn = new Session(new NullOrmClassToolMap(), dsProvider.getSessionStrategy());
			final ITransaction tx = conn.beginTransaction();
			tx.rollback();
			System.out.println("rollback: " + i);
		}
	}
}
